Package: irtDemo
Type: Package
Title: Item Response Theory Demo Collection
Version: 0.1.5
Date: 2025-04-21
Authors@R: 
  c(person(given = "Metin", family = "Bulus", role = c("aut", "cre"), email = "bulusmetin@gmail.com"),
    person(given = "Wes", family = "Bonifay", role = c("aut", "ctb")))
Maintainer: Metin Bulus <bulusmetin@gmail.com>
Description: 
  Includes a collection of shiny applications to demonstrate
  or to explore fundamental item response theory (IRT) concepts
  such as estimation, scoring, and multidimensional IRT models.
Depends: R (>= 3.2.4)
Imports: shiny (>= 0.13.2), fGarch (>= 3010.82)
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2025-04-22 04:01:39 UTC; LENOVO
Author: Metin Bulus [aut, cre],
  Wes Bonifay [aut, ctb]
Repository: CRAN
Date/Publication: 2025-04-22 04:20:02 UTC
Built: R 4.6.0; ; 2026-04-28 18:35:59 UTC; unix

Package: irtDemo
Type: Package
Title: Item Response Theory Demo Collection
Version: 0.1.5
Date: 2025-04-21
Authors@R: 
  c(person(given = "Metin", family = "Bulus", role = c("aut", "cre"), email = "bulusmetin@gmail.com"),
    person(given = "Wes", family = "Bonifay", role = c("aut", "ctb")))
Maintainer: Metin Bulus <bulusmetin@gmail.com>
Description: 
  Includes a collection of shiny applications to demonstrate
  or to explore fundamental item response theory (IRT) concepts
  such as estimation, scoring, and multidimensional IRT models.
Depends: R (>= 3.2.4)
Imports: shiny (>= 0.13.2), fGarch (>= 3010.82)
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2025-04-22 04:01:39 UTC; LENOVO
Author: Metin Bulus [aut, cre],
  Wes Bonifay [aut, ctb]
Repository: CRAN
Date/Publication: 2025-04-22 04:20:02 UTC
Built: R 4.6.0; ; 2026-04-25 19:09:36 UTC; unix

# Item Response Theory Demo Collection

The package can be installed and loaded as:
```{r}
install.packages("irtDemo")
library(irtDemo)
```
Example usage:
```{r}
irtDemo("eapmap")
irtDemo("mirt")
irtDemo("mle")
irtDemo("est2pl")
irtDemo("est3pl")
```
Shiny web applications:   
https://irtdemo.shinyapps.io/eapmap/    
https://irtdemo.shinyapps.io/mirt/   
https://irtdemo.shinyapps.io/mlest/  
https://irtdemo.shinyapps.io/est2pl/   
https://irtdemo.shinyapps.io/est3pl/    
   
Bulus, M., & Bonifay, W.  (2022). irtDemo R Package: Pedagogical Interactive Web Applications for Estimation, Scoring, and Multi Dimensionality in Item Response Theory. Anadolu University Journal of Education Faculty, 6(1), 92-108. https://doi.org/10.34056/aujef.913781

shinyUI(

  fluidPage(title="mle3pl",

    titlePanel("Maximum Likelihood Estimation of Item Discrimination, Location and Lower Asymptote in 3PL Model"),

    sidebarPanel(width=3,
      sliderInput("guess", label = "Lower Asymptote",
                  min = 0.05, max = 0.6, value = 0.4, step = 0.05),
      sliderInput("alpha", label = "Discrimination",
                  min = -3, max = 3, value = 1, step = 0.15),
      sliderInput("delta", label = "Location",
                  min = -3, max = 3, value = -0.5, step = 0.15),
      actionButton(inputId="submit", label="Submit")
    ),
    mainPanel(
      inputPanel(
                   sliderInput("angle1", label = "Rotate Left-Right",
                               min = 0, max = 90, value = 30, step = 1),
                   sliderInput("angle2", label = "Rotate Up-Down",
                               min = 0, max = 90, value = 30, step = 1)
      ),
      helpText("Note: The graph may take a minute to update!"),
      plotOutput(outputId="est3PL_plot_all",width="100%", height="600px")
    )
  )
)

N <- 50
thetas <- seq(from=-3, to=3, length.out = N)
deltas <- seq(from=-3, to=3, by=0.1)
alphas <- seq(from=-3, to=3, by=0.1)
k <- length(deltas)
# define probability function for 2PL model
Pfun <- function(theta, alpha, delta, D=1, u=1){
  z = D*alpha*(theta-delta)
  P = exp(u*z) / (1 + exp(z))
  return(P)
}

la <- seq(from=0.05, to=0.6, by=0.1)
ua <- seq(from=0.05, to=0.6, by=0.1)
thetas <- seq(from=-6, to=6, by=0.1)
deltas <- seq(from=-6, to=6, by=0.1)
alphas <- seq(from=-6, to=6, by=0.1)
N = length(thetas)

p1 <- matrix(NA,nrow=N,1)

# define a generic probability function 
Pfun <- function(la=0, ua=1, alpha=1, theta, delta, D=1){
  z = D*alpha*(theta-delta)
  P = la + ((ua-la)/(1 + exp(-z)))
  return(P)
}

shinyServer(function(input, output){
  
  output$nrm_plot <- renderPlot({
    
    D <- switch(input$D, "1" = 1, "2" = 1.702)
    
    
    p1num=1
    for(j in 1:N){
        p2num[j] <- p2fun(D=D, theta=thetas[j], alpha=input$alpha1, delta1=input$delta1)
        p3num[j] <- p3fun(D=D, theta=thetas[j], alpha=input$alpha2, delta2=input$delta2)
        p4num[j] <- p4fun(D=D, theta=thetas[j], alpha=input$alpha3, delta3=input$delta3)
        p5num[j] <- p5fun(D=D, theta=thetas[j], alpha=input$alpha4, delta4=input$delta4)
    }
    
    pdenom <- 1+p2num+p3num+p4num+p5num
    
    p1 <- p1num/pdenom
    p2 <- p2num/pdenom
    p3 <- p3num/pdenom
    p4 <- p4num/pdenom
    p5 <- p5num/pdenom
    
    graphics::plot(NULL, ylab="P(X=m|theta)", xlab=expression(theta), main="Nominal Response Model", 
              sub="Note: Baker's (1992) reparametrization is used.", xlim=c(-6,6), ylim=c(0,1))
    
    lines(thetas, p1, type="l",  xlim=c(-6,6), col=2)
    lines(thetas, p2, type="l",  xlim=c(-6,6), col=3)
    lines(thetas, p3, type="l",  xlim=c(-6,6), col=4)
    lines(thetas, p4, type="l",  xlim=c(-6,6), col=5)
    lines(thetas, p5, type="l",  xlim=c(-6,6), col=6)
    legend(legend=c("P(X=a|theta)", "P(X=b|theta)","P(X=c|theta)","P(X=d|theta)","P(X=e|theta)"), col=2:6, lty=1, "right")

  })
  
})
  

thetas <- seq(from=-6, to=6, by=0.1)
deltas <- seq(from=-6, to=6, by=0.1)
alphas <- seq(from=-6, to=6, by=0.1)
N = length(thetas)

# define probability function 
p2num <- matrix(NA,nrow=N,ncol=1)
p3num <- matrix(NA,nrow=N,ncol=1)
p4num <- matrix(NA,nrow=N,ncol=1)
p5num <- matrix(NA,nrow=N,ncol=1)

p2fun <- function(alpha1, theta, delta1, D){
  z1 <- D*alpha1*(theta-delta1)
  p2num <- exp(z1)
  return(p2num)
}

p3fun <- function(alpha2, theta, delta2, D){
  z2 <- D*alpha2*(theta-delta2)
  p3num <- exp(z2)
  return(p3num)
}

p4fun <- function(alpha3, theta, delta3, D){
  z3 <- D*alpha3*(theta-delta3)
  p4num <- exp(z3)
  return(p4num)
}

p5fun <- function(alpha4, theta, delta4, D){
  z4 <- D*alpha4*(theta-delta4)
  p5num <- exp(z4)
  return(p5num)
}

shinyUI(

  fluidPage(title="mle2pl",

    titlePanel("Maximum Likelihood Estimation of Item
                     Discrimination and Location in 2PL Model"),

    sidebarPanel(width=3,
      sliderInput("alpha", label = "Discrimination",
                  min = -3, max = 3, value = 1, step = 0.1),
      sliderInput("delta", label = "Location",
                  min = -3, max = 3, value = -0.5, step = 0.1),
      actionButton(inputId="submit", label="Submit")
    ),
    mainPanel(
      inputPanel(
        sliderInput("angle1", label = "Rotate Right-Left",
                    min = 0, max = 90, value = 30, step = 1),
        sliderInput("angle2", label = "Rotate Up-Down",
                    min = 0, max = 90, value = 30, step = 1)
      ),
      plotOutput(outputId="est2PL_plot",width="100%", height="600px"),
      helpText("Note: Values on the control panel are true values and
               projection of red dot corresponds to the intersection of
               discrimination and difficulty parameters that maximize the joint log-likelihood.")
    )
  )
)

shinyUI(
  fluidPage(title="dich",

    titlePanel("Dichotomous IRT Models"),

    sidebarPanel(width=3,
                 selectInput("D", label = "Item Response Function",
                             list("Normal Ogive" = 1, "Logistic"=2), selected = 2),
        sliderInput("alpha", label = "Discrimination (a)",
                  min = -3, max = 3, value = 1, step = .5),
        sliderInput("delta", label = "Location (b)",
                  min = -3, max = 3, value = 0, step = .5),
        sliderInput("la", label = "Lower Asymptote (c)",
                    min = 0, max = 0.4, value = 0, step = .1),
        sliderInput("ua", label = "Upper Asymptote (d)",
                    min = .6, max = 1, value = 1, step = .1),
        selectInput("modprob", label = "Modeled Probability",
                    list("P(X=1|theta)" = 1, "P(X|theta)"=2), selected = 2)
      ),
  mainPanel(
    plotOutput(outputId="dich_plot", height="600px"),
    verbatimTextOutput(outputId="feedback")
  )
)
)

shinyServer(function(input, output) {

    # simulate reponses for 3PL model
    pcorrmtx <- reactive({
      pcorrmtx <- matrix(NA, nrow=N, ncol=1)
      for(j in 1:N){
        pcorrmtx[j] <- Pfun(guess=input$guess, theta=thetas[j], delta=input$delta, alpha=input$alpha)
      }
      pcorrmtx
    })


    datamtx <- reactive({
      pcorrmtx <- pcorrmtx()
      datamtx <- matrix(NA, nrow=N, ncol=1)
      for(j in 1:N){
        datamtx[j] <- rbinom(1,1,pcorrmtx[j])
      }
      datamtx
    })


    logLike1 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
        for (m in 1:k){
          for(n in 1:k){
            for (j in 1:N){
              pik[m,n,j] <- Pfun(guess=guesses[1], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
            }
            logLike[m,n] <- sum(log(pik[m,n,]))
          }
        }
       logLike
      })

    logLike2 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[2], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike3 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[3], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike4 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[4], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike5 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[5], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike6 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[6], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike7 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[7], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike8 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[8], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike9 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[9], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike10 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[10], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike11 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[11], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    logLike12 <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      for (m in 1:k){
        for(n in 1:k){
          for (j in 1:N){
            pik[m,n,j] <- Pfun(guess=guesses[12], theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
          }
          logLike[m,n] <- sum(log(pik[m,n,]))
        }
      }
      logLike
    })

    xy1 <- reactive({
      logLike1 <- logLike1()
      which(logLike1==max(logLike1), TRUE)
      })

    xy2 <- reactive({
      logLike2 <- logLike2()
      which(logLike2==max(logLike2), TRUE)
    })

    xy3 <- reactive({
      logLike3 <- logLike3()
      which(logLike3==max(logLike3), TRUE)
    })

    xy4 <- reactive({
      logLike4 <- logLike4()
      which(logLike4==max(logLike4), TRUE)
    })

    xy5 <- reactive({
      logLike5 <- logLike5()
      which(logLike5==max(logLike5), TRUE)
    })

    xy6 <- reactive({
      logLike6 <- logLike6()
      which(logLike6==max(logLike6), TRUE)
    })

    xy7 <- reactive({
      logLike7 <- logLike7()
      which(logLike7==max(logLike7), TRUE)
    })

    xy8 <- reactive({
      logLike8 <- logLike8()
      which(logLike8==max(logLike8), TRUE)
    })

    xy9 <- reactive({
      logLike9 <- logLike9()
      which(logLike9==max(logLike9), TRUE)
    })

    xy10 <- reactive({
      logLike10 <- logLike10()
      which(logLike10==max(logLike10), TRUE)
    })

    xy11 <- reactive({
      logLike11 <- logLike11()
      which(logLike11==max(logLike11), TRUE)
    })

    xy12 <- reactive({
      logLike12 <- logLike12()
      which(logLike12==max(logLike12), TRUE)
    })

    observe({
      if(input$submit>0) {

      output$est3PL_plot_all <- renderPlot({
        xy1 <- isolate(xy1())
        logLike1 <- isolate(logLike1())
        xy2 <- isolate(xy2())
        logLike2 <- isolate(logLike2())
        xy3 <- isolate(xy3())
        logLike3 <- isolate(logLike3())
        xy4 <- isolate(xy4())
        logLike4 <- isolate(logLike4())
        xy5 <- isolate(xy5())
        logLike5 <- isolate(logLike5())
        xy6 <- isolate(xy6())
        logLike6 <- isolate(logLike6())
        xy7 <- isolate(xy7())
        logLike7 <- isolate(logLike7())
        xy8 <- isolate(xy8())
        logLike8 <- isolate(logLike8())
        xy9 <- isolate(xy9())
        logLike9 <- isolate(logLike9())
        xy10 <- isolate(xy10())
        logLike10 <- isolate(logLike10())
        xy11 <- isolate(xy11())
        logLike11 <- isolate(logLike11())
        xy12 <- isolate(xy12())
        logLike12 <- isolate(logLike12())

          # plot joint log-likelihood as function of guess, alpha and delta parameters
          logLike3D1 <-  graphics::persp(alphas, deltas, logLike1,
                               theta=input$angle1, phi=input$angle2,
                               ltheta = 120, shade = 0.75, col=2,
                               xlab="Discrimination",
                               ylab="Location",
                               zlab="Log-Likelihood",
                               nticks = 5, ticktype = "detailed")

          par(new=TRUE)
          logLike3D2 <-  graphics::persp(alphas, deltas, logLike2,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=3,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D3 <-  graphics::persp(alphas, deltas, logLike3,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=4,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D4 <-  graphics::persp(alphas, deltas, logLike4,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=5,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D5 <-  graphics::persp(alphas, deltas, logLike5,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=6,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D6 <-  graphics::persp(alphas, deltas, logLike6,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=7,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D7 <-  graphics::persp(alphas, deltas, logLike7,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=8,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D8 <-  graphics::persp(alphas, deltas, logLike8,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=9,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D9 <-  graphics::persp(alphas, deltas, logLike9,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=10,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D10 <-  graphics::persp(alphas, deltas, logLike10,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=11,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D11 <-  graphics::persp(alphas, deltas, logLike11,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=12,
                              xlab="",
                              ylab="",
                              zlab="")

          par(new=TRUE)
          logLike3D12 <- graphics::persp(alphas, deltas, logLike12,
                              ltheta = 120, shade = 0.75,
                              theta=input$angle1, phi=input$angle2, col=13,
                              xlab="",
                              ylab="",
                              zlab="")

          maxLL  <- max(logLike1[xy1[1,1],xy1[1,2]],
                        logLike2[xy2[1,1],xy2[1,2]],
                        logLike3[xy3[1,1],xy3[1,2]],
                        logLike4[xy4[1,1],xy4[1,2]],
                        logLike5[xy5[1,1],xy3[1,2]],
                        logLike6[xy6[1,1],xy1[1,2]],
                        logLike7[xy7[1,1],xy2[1,2]],
                        logLike8[xy8[1,1],xy3[1,2]],
                        logLike9[xy9[1,1],xy4[1,2]],
                        logLike10[xy7[1,1],xy2[1,2]],
                        logLike11[xy8[1,1],xy3[1,2]],
                        logLike12[xy9[1,1],xy4[1,2]])

              points(trans3d(alphas[xy1[1,1]], deltas[xy1[1,2]], logLike1[xy1[1,1],xy1[1,2]], logLike3D1), col='black', pch=21, bg = 2, cex=1.5)
              points(trans3d(alphas[xy2[1,1]], deltas[xy2[1,2]], logLike2[xy2[1,1],xy2[1,2]], logLike3D2), col='black', pch=21, bg = 3, cex=1.5)
              points(trans3d(alphas[xy3[1,1]], deltas[xy3[1,2]], logLike3[xy3[1,1],xy3[1,2]], logLike3D3), col='black', pch=21, bg = 4, cex=1.5)
              points(trans3d(alphas[xy4[1,1]], deltas[xy4[1,2]], logLike4[xy4[1,1],xy4[1,2]], logLike3D4), col='black', pch=21, bg = 5, cex=1.5)
              points(trans3d(alphas[xy5[1,1]], deltas[xy5[1,2]], logLike5[xy5[1,1],xy3[1,2]], logLike3D5), col='black', pch=21, bg = 6, cex=1.5)
              points(trans3d(alphas[xy6[1,1]], deltas[xy6[1,2]], logLike6[xy6[1,1],xy1[1,2]], logLike3D6), col='black', pch=21, bg = 7, cex=1.5)
              points(trans3d(alphas[xy7[1,1]], deltas[xy7[1,2]], logLike7[xy7[1,1],xy2[1,2]], logLike3D7), col='black', pch=21, bg = 8, cex=1.5)
              points(trans3d(alphas[xy8[1,1]], deltas[xy8[1,2]], logLike8[xy8[1,1],xy3[1,2]], logLike3D8), col='black', pch=21, bg = 9, cex=1.5)
              points(trans3d(alphas[xy9[1,1]], deltas[xy9[1,2]], logLike9[xy9[1,1],xy4[1,2]], logLike3D9), col='black', pch=21, bg = 10, cex=1.5)
          points(trans3d(alphas[xy10[1,1]], deltas[xy10[1,2]], logLike10[xy10[1,1],xy3[1,2]], logLike3D10), col='black', pch=21, bg = 11, cex=1.5)
          points(trans3d(alphas[xy11[1,1]], deltas[xy11[1,2]], logLike11[xy11[1,1],xy1[1,2]], logLike3D11), col='black', pch=21, bg = 12, cex=1.5)
          points(trans3d(alphas[xy12[1,1]], deltas[xy12[1,2]], logLike12[xy12[1,1],xy2[1,2]], logLike3D12), col='black', pch=21, bg = 13, cex=1.5)

          legend(legend=paste("c=", seq(0.05, .60, .05), sep=""), col=2:13, pch=19, title="Lower Asymptote", "right")
        })

      }
    })
})

shinyUI(

  fluidPage(title="eapmap",

  titlePanel("EAP and MAP Person Ability Estimation in Rasch Model"),

  sidebarPanel(width=3,
      sliderInput("r", label = "Raw Score (r)",
                  min = 0, max = 5, value = 2, step = 1),
      sliderInput("quad", label = "Quadrature Points",
                  min = 10, max = 100, value = 41, step = 10),
      sliderInput("mean",
                  label="Prior Mean",
                  min=-2, max=2, value=0, step=0.1),
      sliderInput("sd",
                   label="Prior SD",
                   min=0.1, max=2, value=1, step=0.1),
      sliderInput("skew", label = "Prior Skewness",
                  min = .5, max = 2, value = 1, step = .1)
  ),

  mainPanel(
    tabsetPanel(
        tabPanel("Seperate",
                splitLayout(
                   cellWidths = 450,
                   plotOutput("Prior_plot"),
                   plotOutput("TraceLines_plot")
                ),
                splitLayout(
                  cellWidths = 450,
                  plotOutput("Likelihood_plot"),
                  plotOutput("Posterior_plot")
                ),
                helpText("Note: Respondent's raw score are assumed to come from following patterns: r=0, patt=00000; r=1, patt=10000;
                         r=2, patt=11000; r=3, patt=11100; r=4, patt=11110;
                         and r=5, patt=11111.Default values replicate the analysis in de Ayala (2009, p. 79)
                         where difficulty parameters for Item 1-5 are fixed at -2.155, -.245, .206, .984, and 1.211."
                )
              ),

        tabPanel("Combined", plotOutput(outputId="Combined_plot",width="100%", height="600px"))
     )
   )
  )
)

shinyServer(function(input, output) {

     Xr <- reactive({
       seq(-4,4,length=input$quad) # equal distance abilities for quadrature
     })

     pattInput <- reactive({
      c(rep(1,input$r), rep(0,5-input$r)) # response pattern
     })

     # plot prior
     AXr <- reactive({
       Xr <- Xr()
       fGarch::dsnorm(Xr, mean=input$mean, sd=input$sd, xi = input$skew, log = FALSE)/sum(fGarch::dsnorm(Xr, mean=input$mean, sd=input$sd, xi = input$skew, log = FALSE))
     })

     pji <- reactive({
       Xr <- Xr()
       N <- length(Xr)
       pji <- matrix(NA,N,n)
       for(j in 1:N){
           for(i in 1:n){
               patt <- pattInput()
               Xr <- Xr()
               pji[j,i] <- PLfun(theta=Xr[j], alpha=alphas[i], delta=deltas[i], u=patt[i])
           }
       }
       pji
     })

     LXr <- reactive({
       pji <- pji()
       Xr <- Xr()
       N <- length(Xr)
       LXr <- matrix(NA,N,1)
       for(j in 1:N){
             LXr[j] <- prod(pji[j,])
       }
       LXr
     })

     output$Prior_plot <- renderPlot({
       Xr <- Xr()
       AXr <- AXr()
       graphics::plot(Xr, AXr, type='l', xlab=expression(X[r]), ylab=expression(A(X[r])),
            xlim=c(-6,6),
            main=expression(paste("Prior Distribution of ", theta)))
       inc <- (abs(Xr[2]-Xr[1])/2)
         for(i in 1:length(Xr)){
           polygon(x=c(Xr[i]-inc, Xr[i]+inc,Xr[i]+inc, Xr[i]-inc) , y=c(0,0,AXr[i],AXr[i]), density = c(30))
         }
       })


     output$TraceLines_plot <- renderPlot({
       Xr <- Xr()
       pji <- pji()
       patt <- pattInput()
       # plot trace lines
       graphics::plot(NULL, xlim=c(-3,3), ylim=c(0,1), xlab=expression(X[r]),
            ylab=expression(P(X[r])),
            main=expression(paste("Item Tracelines")))
       for(i in 1:n){
         lines(Xr, pji[,i], type='l', col=2+patt[i]*2)
       }
       legend(legend=c(1,0), col=c(4,2), lty=1, title="Response", "right")
     })


     output$Likelihood_plot <- renderPlot({
       Xr <- Xr()
       LXr <- LXr()
       # plot likelihood
       graphics::plot(Xr, LXr, type='l', xlab=expression(X[r]), ylab=expression(L(X[r])),
            xlim=c(-3,3),
            main=expression(paste("Likelihood")))
     })

     output$Posterior_plot<- renderPlot({
       Xr <- Xr()
       AXr <- AXr()
       LXr <- LXr()
       # plot posterior
       graphics::plot(Xr, AXr*LXr, type='l', xlab=expression(X[r]), ylab=expression(paste(A(X[r])," * ", L(X[r]))),
            xlim=c(-2.5,2.5),
            main=expression(paste("Posterior Distribution of ", theta)))
       EAP <- sum(Xr*AXr*LXr)/sum(AXr*LXr)
       PSD <- sqrt(sum((Xr-EAP)^2*LXr*AXr)/sum(LXr*AXr))
       MAP <- Xr[which.max(AXr*LXr)] #now it makes sense why it is iterative
       abline(v=EAP, col=4)
       abline(v=MAP,col=2)
       text(-1.8, max(AXr*LXr)*.9, paste('EAP =',round(EAP,4)),col=4)
       text(1.8, max(AXr*LXr)*.9, paste('MAP =',round(MAP,4)),col=2)
     })

     output$Combined_plot<- renderPlot({
       Xr <- Xr()
       AXr <- AXr()
       LXr <- LXr()
       # plot posterior
       graphics::plot(Xr, 5*AXr*LXr, type='l', xlab=expression(X[r]), ylab=expression(f(X[r])), ylim=c(0,0.20), xlim=c(-4,4),
                                    main=expression(paste("Prior, Likelihood, and Posterior Distributions")),
                                    sub=expression(paste("Note: Posterior distribution is rescaled")))
       # plot likelihood
       lines(Xr, LXr, type='l', col="blue")
       # plot prior
       lines(Xr, AXr, type='l', col="red")

       EAP <- sum(Xr*AXr*LXr)/sum(AXr*LXr)
       text(-3, 0.2, paste('Posterior Mean =',round(EAP,2)), col="black")
       text(3, 0.2, paste('Prior Mean =', input$mean), col="red")
       abline(v=input$mean,col="red", lty=2)
       abline(v=EAP, col="black", lty=2)

       legend(legend=c("Prior","Likelihood", "Posterior"), col=c("red","blue","black"), lty=1, title="Distribution", "right")
     })
})

shinyUI(

  fluidPage(title="grsm",

  titlePanel("RSM (default) and GRSM"),

   sidebarPanel(width=3,
                selectInput("D", label = "Item Response Function",
                            list("Normal Ogive" = 1, "Logistic"=2), selected = 2),
        sliderInput("alpha", label = "Discrimination",
                  min = -3, max = 3, value = 1, step = .5),
        sliderInput("delta", label = "Difficulty",
                    min = -3, max = 3, value = 0, step = .5),
        sliderInput("tau1", label = "Threshold 1",
                  min = -3, max = 3, value = -1, step = .5),
        sliderInput("tau2", label = "Threshold 2",
                    min = -3, max = 3, value = -0.4, step = .5),
        sliderInput("tau3", label = "Threshold 3",
                    min = -3, max = 3, value = 0.4, step = .5),
        sliderInput("tau4", label = "Threshold 4",
                    min = -3, max = 3, value = 1, step = .5)
      ),
    mainPanel(
      plotOutput(outputId="grsm_plot", height="600px")
    )
  )
)

shinyServer(function(input, output) {

    pjj <- reactive({

      D <- switch(input$D, "1" = 1, "2" = 1.702)
      comp <- switch(input$comp, "1" = 1, "2" = 2)
      pjj <- matrix(NA,nrow=N,ncol=N)
      if(comp==1){
        for(j1 in 1:N){
          for (j2 in 1:N){
            pjj[j1,j2] <- Pfun(theta1=thetas1[j1], theta2=thetas2[j2], c=input$c, d=input$d, alpha1=input$alpha1,
                               alpha2=input$alpha2, delta1=input$delta1, delta2=input$delta2, D=D)
          }
        }
      }

      if(comp==2){
        for(j1 in 1:N){
          for (j2 in 1:N){
            pjj[j1,j2] <- Pfun2(theta1=thetas1[j1], theta2=thetas2[j2], c=input$c, d=input$d, alpha1=input$alpha1,
                               alpha2=input$alpha2, delta1=input$delta1, delta2=input$delta2, D=D)
          }
        }
      }
      pjj

    })

    output$M2PL_plot <- renderPlot({
        pjj <- pjj()
        # plot probability as function of theta1 and theta2
        p3D <-  graphics::persp(thetas1, thetas2, pjj,
                             theta=input$angle1, phi=input$angle2,
                             zlim=c(0,1),
                             xlab=input$nametheta1,
                             ylab=input$nametheta2,
                             zlab="P(Y=1|theta)",
                             nticks = 5, ticktype = "detailed"
                            )
      })

    output$cont_plot <- renderPlot({

      pjj <- pjj()
      c <- input$c
      d <- input$d
      alpha1 <- input$alpha1
      alpha2 <- input$alpha2
      delta1 <- input$delta1
      delta2 <- input$delta2
      gamma <- -(alpha1*delta1+alpha2*delta2)
      omega1 <- acos(alpha1/sqrt(alpha1^2+alpha2^2)) #in radians
      omega2 <- acos(alpha2/sqrt(alpha1^2+alpha2^2)) #in radians

      Ai <- sqrt(alpha1^2+alpha2^2) #multidimensional discrimination
      Di <- -gamma/Ai

      # plot probability as function of theta1 and theta2
       graphics::contour(thetas1, thetas2, pjj, nlevels=input$nlevels,
                   xlab=input$nametheta1,
                   ylab=input$nametheta2
                   )
        abline(h=0,v=0)
        if(c==0 & d==1){
          cont <- contourLines(thetas1, thetas2, pjj, levels=0.5)
          lines(cont[[1]]$x, cont[[1]]$y, lwd=2)
        }
        if(c>0 & d==1){
          cont <- contourLines(thetas1, thetas2, pjj, levels=(c+1)/2)
          lines(cont[[1]]$x, cont[[1]]$y, lwd=2)
        }
        if(c>0 & d<1){
          cont <- contourLines(thetas1, thetas2, pjj, levels=(c+d)/2)
          lines(cont[[1]]$x, cont[[1]]$y, lwd=2)
        }

        comp <- switch(input$comp, "1" = 1, "2" = 2)
        if(comp==1){
          if(alpha2>0){
            arrows(Di*cos(omega1), Di*sin(omega1),
                   x1=(Di+Ai)*cos(omega1),
                   y1=(Di+Ai)*sin(omega1), code=2, length=0.1, col="blue")
          }
          if(alpha2<0){
            arrows((Di+Ai)*cos(omega1), -(Di+Ai)*sin(omega1),
                   x1=Di*cos(omega1),
                   y1=-Di*sin(omega1), code=1, length=0.1, col="blue")
          }
        }
    })

    output$info_plot <- renderPlot({
      c <- input$c
      d <- input$d
      alpha1 <- input$alpha1
      alpha2 <- input$alpha2
      Ai <- sqrt(alpha1^2+alpha2^2) #multidimensional discrimination
      pjj <- pjj()
      info <- matrix(NA,nrow=N,ncol=N)
        for(j1 in 1:N){
          for (j2 in 1:N){
            info[j1,j2] <- (Ai^2)*((pjj[j1,j2]-c)^2)*((d-pjj[j1,j2])^2)/((d-c)^2)*((1-pjj[j1,j2])*pjj[j1,j2]) # (Magis, 2013)
          }
        }

       graphics::persp(thetas1, thetas2, info,
            theta=input$angle3, phi=input$angle4,
            zlim=c(0,max(info) +.01),
            xlab=input$nametheta1,
            ylab=input$nametheta2,
            zlab="information",
            nticks = 5, ticktype = "detailed"
            )
    })

    output$parms1 <- renderText({
      paste("Item parameters: ","a1=",input$alpha1,
            ", a2=",input$alpha2,", b1=",input$delta1,
            ", b2=",input$delta2,", c=",input$c,
            ", d=",input$d, sep="")
    })

    output$parms2 <- renderText({
      paste("Item parameters: ","a1=",input$alpha1,
            ", a2=",input$alpha2,", b1=",input$delta1,
            ", b2=",input$delta2,", c=",input$c,
            ", d=",input$d, sep="")
    })

    output$parms3 <- renderText({
      paste("Item parameters: ","a1=",input$alpha1,
            ", a2=",input$alpha2,", b1=",input$delta1,
            ", b2=",input$delta2,", c=",input$c,
            ", d=",input$d, sep="")
    })

})

N <- 50
# independent thetas
 thetas1 <- seq(from=-4, to=4, length.out = N)
 thetas2 <- seq(from=-4, to=4, length.out = N)

pjj <- matrix(NA,nrow=N,ncol=N)

# define probability function for M3PL compensatory model
Pfun <- function(theta1, theta2, c, d, alpha1, alpha2, delta1, delta2, D){
  gamma <- -(alpha1*delta1 + alpha2*delta2)
  alpha <- matrix(c(alpha1,alpha2), nrow=2, ncol=1)
  theta <- matrix(c(theta1,theta2), nrow=2, ncol=1)
  z <- D*(t(alpha)%*%theta + gamma)
  P <- c + (d-c)*(1/(1+exp(-z)))
  return(P)
}

# define probability function for M3PL noncompensatory model
Pfun2 <- function(theta1, theta2, c, d, alpha1, alpha2, delta1, delta2, D){
  gamma1 <- -(alpha1*delta1)
  gamma2 <- -(alpha2*delta2)
  z1 <- D*(alpha1*theta1 + gamma1)
  z2 <- D*(alpha2*theta2 + gamma2)
  P <- c + (d-c)*(1/(1+exp(-z1)))*(1/(1+exp(-z2)))
  return(P)
}

shinyUI(

  fluidPage(title="mle",

  titlePanel("Maximum Likelihood Estimation (MLE) of
             Person Location in Rasch Model given Item Difficulty"),

  sidebarPanel(width=4,
     sliderInput("r", label = "Raw Score (r)",
                 min = 0, max = 5, value = 2, step = 1),
     sliderInput("t_0", label = "Starting Value",
                 min = -2, max = 2, value = 0, step = 0.5),
     sliderInput("iter", label = "Iteration",
                 min = 1, max = 5, value = 1, step = 1),
     strong("Note:"),
     p("Respondent's raw score are assumed to come from
       following patterns: r=0, patt=00000; r=1, patt=10000;
       r=2, patt=11000; r=3, patt=11100; r=4, patt=11110;
       and r=5, patt=11111. Item difficulties for five item instrument are assumed
       to be known (-1.90, -0.60, -0.25, 0.30, 0.45) and are provided
       in de Ayala (2009, p.22). This app replicates person locations
       in Table 2.2 in de Ayala (2009, p.28)"
     )
    ),

    mainPanel(
        plotOutput(outputId="MLEIRT_plot", height="500px"),
        verbatimTextOutput("iterinfo")
    )

))

shinyUI(
  fluidPage(title="gpcm",

  titlePanel("Rasch PCM (default) and 2PL GPCM"),

    sidebarPanel(width=3,
                 selectInput("D", label = "Item Response Function",
                             list("Normal Ogive" = 1, "Logistic"=2), selected = 2),
        sliderInput("alpha", label = "Discrimination",
                  min = -3, max = 3, value = 1, step = .5),
        sliderInput("delta1", label = "Step parameter 1",
                  min = -3, max = 3, value = -2, step = .5),
        sliderInput("delta2", label = "Step parameter 2",
                    min = -3, max = 3, value = -0.75, step = .5),
        sliderInput("delta3", label = "Step parameter 3",
                    min = -3, max = 3, value = 0.75, step = .5),
        sliderInput("delta4", label = "Step parameter 4",
                    min = -3, max = 3, value = 2, step = .5)
      ),

    mainPanel(
      plotOutput(outputId="gpcm_plot", height="600px")
    )
  )
)

shinyServer(function(input, output){

  output$gpcm_plot <- renderPlot({

    D <- switch(input$D, "1" = 1, "2" = 1.702)

    p1num=1
    for(j in 1:N){
        p2num[j] <- p2fun(D=D, theta=thetas[j], alpha=input$alpha, delta1=input$delta1)
        p3num[j] <- p3fun(D=D, theta=thetas[j], alpha=input$alpha, delta1=input$delta1, delta2=input$delta2)
        p4num[j] <- p4fun(D=D, theta=thetas[j], alpha=input$alpha, delta1=input$delta1, delta2=input$delta2, delta3=input$delta3)
        p5num[j] <- p5fun(D=D, theta=thetas[j], alpha=input$alpha, delta1=input$delta1, delta2=input$delta2, delta3=input$delta3, delta4=input$delta4)
    }

    pdenom <- 1+p2num+p3num+p4num+p5num

    p1 <- p1num/pdenom
    p2 <- p2num/pdenom
    p3 <- p3num/pdenom
    p4 <- p4num/pdenom
    p5 <- p5num/pdenom

    title <- ifelse(input$alpha==1, "Partial Credit Model (Masters, 1982)",
                          "Generalized Partial Credit Model (Muraki, 1992)")

     graphics::plot(NULL, ylab=expression(P(X)), xlab=expression(theta), main=paste(title), xlim=c(-6,6), ylim=c(0,1))

    lines(thetas, p1, type="l",  xlim=c(-6,6), col=2)
    lines(thetas, p2, type="l",  xlim=c(-6,6), col=3)
    lines(thetas, p3, type="l",  xlim=c(-6,6), col=4)
    lines(thetas, p4, type="l",  xlim=c(-6,6), col=5)
    lines(thetas, p5, type="l",  xlim=c(-6,6), col=6)
    legend(legend=c("P(X=1|theta)", "P(X=2|theta)","P(X=3|theta)","P(X=4|theta)","P(X=5|theta)"), col=2:6, lty=1, "right")

  })

})

shinyUI(

  fluidPage(title="mirt",
      titlePanel(h1("Multidimensional Dichotomous Models")),
      titlePanel(h3("(Rasch, 1PL, 2PL, 3PL, and 4PL)")),
        sidebarPanel(width=3,
          selectInput("D", label = "Item Response Function",
                       list("Normal Ogive" = 1, "Logistic"=2), selected = 2),
          selectInput("comp", label = "Compensatory",
                      list("Yes" = 1, "No"=2), selected = 1),
          sliderInput("delta1", label = "Location 1",
                      min = -3, max = 3, value = 0, step = 0.1),
          sliderInput("delta2", label = "Location 2",
                      min = -3, max = 3, value = 0, step = 0.1),
          sliderInput("alpha1", label = "Discrimination 1",
                      min = -3, max = 3, value = 1, step = 0.1),
          sliderInput("alpha2", label = "Discrimination 2",
                      min = -3, max = 3, value = 1, step = 0.1),
          sliderInput("c", label = "Lower Asymptote",
                      min = 0, max = .4, value = 0, step = 0.1),
          sliderInput("d", label = "Upper Asymptote",
                      min = .6, max = 1, value = 1, step = 0.1),
          textInput("nametheta1", label="Name Dimension 1", "Math"),
          textInput("nametheta2", label="Name Dimension 2", "Reading")
        ),
        mainPanel(
          tabsetPanel(
            tabPanel("Item Response Surface",
                     inputPanel(
                       sliderInput("angle1", label = "Rotate Right-Left",
                                   min = 0, max = 90, value = 30, step = 1),
                       sliderInput("angle2", label = "Rotate Up-Down",
                                   min = 0, max = 90, value = 30, step = 1)
                     ),
                     plotOutput(outputId="M2PL_plot",width="650px", height="650px"),
                     verbatimTextOutput(outputId="parms1")),
            tabPanel("Contour Plot",
                     inputPanel(
                       sliderInput("nlevels", label = "N Contour Levels",
                                   min = 10, max = 100, value = 10, step = 1)
                     ),
                     plotOutput(outputId="cont_plot",width="650px", height="650px"),
                     verbatimTextOutput(outputId="parms2")),
            tabPanel("Information Plot",
                     inputPanel(
                       sliderInput("angle3", label = "Rotate Right-Left",
                                   min = 0, max = 90, value = 30, step = 1),
                       sliderInput("angle4", label = "Rotate Up-Down",
                                   min = 0, max = 90, value = 30, step = 1)
                     ),
                     plotOutput(outputId="info_plot",width="650px", height="650px"),
                     verbatimTextOutput(outputId="parms3"))
          )
        )
      )
   )

shinyServer(function(input, output) {

    # simulate reponses for 2PL model
    pcorrmtx <- reactive({
      pcorrmtx <- matrix(NA, nrow=N, ncol=1)
      for(j in 1:N){
        pcorrmtx[j] <- Pfun(theta=thetas[j], delta=input$delta, alpha=input$alpha)
      }
      pcorrmtx
    })


    datamtx <- reactive({
      pcorrmtx <- pcorrmtx()
      datamtx <- matrix(NA, nrow=N, ncol=1)
      for(j in 1:N){
        datamtx[j] <- rbinom(1,1,pcorrmtx[j])
      }
      datamtx
    })


    logLike <- reactive({
      datamtx <- datamtx()
      # calculate the joint log-likelihood
      pik <- array(NA, dim=c(k,k,N))
      logLike <- matrix(NA,k,k)
        for (m in 1:k){
          for(n in 1:k){
            for (j in 1:N){
              pik[m,n,j] <- Pfun(theta=thetas[j], alpha=alphas[m], delta=deltas[n], u=datamtx[j])
            }
            logLike[m,n] <- sum(log(pik[m,n,]))
          }
        }
       logLike
      })

    xy <- reactive({
      logLike <- logLike()
      which(logLike==max(logLike), TRUE)
      })


    observe({
      if(input$submit>0) {

        output$est2PL_plot <- renderPlot({

            xy <- isolate(xy())
            logLike <- isolate(logLike())
            # plot joint log-likelihood as function of alpha and delta
            logLike3D <-  graphics::persp(alphas, deltas, logLike,
                                 theta=input$angle1, phi=input$angle2,
                                 xlab="Discrimination",
                                 ylab="Location",
                                 zlab="Log-Likelihood",
                                 nticks = 5, ticktype = "detailed")
            points(trans3d(alphas[xy[1,1]], deltas[xy[1,2]], logLike[xy[1,1],xy[1,2]], logLike3D), col='black', cex=1.5, pch=21, bg = "red")
          })

      }
    })
})

shinyServer(function(input, output){
  
  
  output$dich_plot <- renderPlot({
    
    D <- switch(input$D, "1" = 1, "2" = 1.702)
    
    for(j in 1:N){
      p1[j] <- Pfun(D=D, la=input$la, ua=input$ua, theta=thetas[j], delta=input$delta, alpha=input$alpha)
    }
    
    if(input$la==0 & input$ua==1 & input$alpha==1){title <- c("Rasch Model")}
    if(input$la==0 & input$ua==1 & input$alpha!=1){title <- c("1PL or 2PL Model")} 
    if(input$ua==1 & input$la!=0){title <- c("3PL Model")} 
    if(input$la!=0 & input$ua!=1){title <- c("4PL Model")} 
    
    output$feedback <- renderText({
      ifelse(input$ua!=1 & input$la==0, "No such model!", paste(title, ": a=",input$alpha," b=",input$delta, " c=", input$la, " d=", input$ua))
    })
    
      
    graphics::plot(NULL, ylab=expression(P(X)), xlab=expression(theta), xlim=c(-6,6), ylim=c(0,1))

    modprob <- switch(input$modprob, "1" = 1, "2" = 2)
    
    if(modprob==1){
      lines(thetas, p1, type="l",  xlim=c(-6,6), col=1)
      legend(legend="P(X=1|theta)", col=1, lty=1, "right")
    }
    
    if(modprob==2){
      lines(thetas, p1, type="l",  xlim=c(-6,6), col=1)
      lines(thetas, 1-p1, type="l",  xlim=c(-6,6), col=2)
      legend(legend=c("P(X=1|theta)", "P(X=0|theta)"), col=c(1,2), lty=1, "right")
    }
  })
})
  

require(fGarch)
# define probability or likelihood function for 2PL model
PLfun <- function(theta, alpha, delta, D=1, u=1){
  z = D*alpha*(theta-delta)
  P = exp(u*z) / (1 + exp(z))
  return(P)
}

alphas <- c(1,1,1,1,1) # discriminations
deltas <- c(-2.155, -.245, .206, .984, 1.211) # de Ayala difficulty estimates (Table 4.4)
n <- length(deltas)

shinyUI(

  fluidPage(title="nrm",

  titlePanel("Nominal Response Model (Bock, 1972)"),

    sidebarPanel(width=3,
        selectInput("D", label = "Item Response Function",
                  list("Normal Ogive" = 1, "Logistic"=2), selected = 2),
        sliderInput("alpha1", label = "Discrimination 1",
                  min = -3, max = 3, value = 0.5, step = .5),
        sliderInput("alpha2", label = "Discrimination 2",
                    min = -3, max = 3, value = 1, step = .5),
        sliderInput("alpha3", label = "Discrimination 3",
                    min = -3, max = 3, value = 1.5, step = .5),
        sliderInput("alpha4", label = "Discrimination 4",
                    min = -3, max = 3, value = 2, step = .5),
        sliderInput("delta1", label = "Location 1",
                    min = -3, max = 3, value = -1, step = .5),
        sliderInput("delta2", label = "Location 2",
                  min = -3, max = 3, value = -0.5, step = .5),
        sliderInput("delta3", label = "Location 3",
                    min = -3, max = 3, value = -0.5, step = .5),
        sliderInput("delta4", label = "Location 4",
                    min = -3, max = 3, value = 1, step = .5)
      ),
  mainPanel(
    plotOutput(outputId="nrm_plot", height="600px")
  )
  )
)

shinyServer(function(input, output) {

   output$MLEIRT_plot <- renderPlot({
     patt <- c(rep(1,input$r), rep(0,5-input$r))
     logLike[,1] <- thetas
     for (j in 1:N) {
       for (i in 1:n) {
         u <- patt[i]
         pji[j,i] <- Pfun(theta=thetas[j], delta=deltas[i], u=patt[i])
       }
       logLike[j,2] <- sum(log(pji[j,]))
       logLike[j,3] <- prod(pji[j,])
     }

     thetahat <- logLike[logLike[,2]==max(logLike[,2]), 1]
     maxLL <- logLike[logLike[,2]==max(logLike[,2]), 2]

     t <- logLike[,1]
     ll <- logLike[,2]
     t_0 <- input$t_0

     for(i in 1:input$iter){
        graphics::plot(t, ll, type='l', xlab=expression(theta), ylab='LogLikelihood',
            xlim=c(-6,6), ylim=c(-15, 1))
       abline(h=0, col=8)
       spline <- smooth.spline(ll ~ t)
       lines(spline, col='black')

       fderiv0 <- predict(spline, x=t_0, deriv=0)
       fderiv1 <- predict(spline, x=t_0, deriv=1)
       fderiv2 <- predict(spline, x=t_0, deriv=2)
       points(fderiv0, col='black', pch=21, bg = "red", cex=1.5) # point to predict tangent
       text(fderiv0$x, fderiv0$y-1, expression(hat(theta)^0))

       t_1 <- t_0 - (fderiv1$y/fderiv2$y)

       theta0 <- t_0
       output$iterinfo <- renderText({
         paste(sep="",
               "Newton-Raphson step:", "\n",
               "theta1 = theta0 - (LL' / LL'')", "\n",
               round(t_1,4)," = ", round(theta0,4), " - ", "(", round(fderiv1$y,4), " / ",round(fderiv2$y,4), ")", "\n",
               "\n",
               "Acute angle with abscissa = ", round(deg, digits=0), " degrees"
         )
       })

       yint <- fderiv0$y - (fderiv1$y*t_0)
       xint <- -yint/fderiv1$y
       lines(t, yint + fderiv1$y*t, col='blue') # tangent (1st deriv. of spline at t_0)

       rad <- atan(fderiv0$y/(xint-t_0))
       deg <- rad*180/pi
       if(round(abs(deg), digits=0)>0){polygon(x=c(xint, t_0, t_0) , y=c(0,0,fderiv0$y), density = c(30))}

       y_1 <- predict(spline, x=t_1, deriv=0)
       points(t_1, y_1$y, col='black', pch=21, bg = "green", cex=1.5)
       text(t_1, y_1$y-1, expression(hat(theta)^1))

       abline(v=t_0, col=8, lty='dotted')
       abline(v=t_1, col=8, lty='dotted')

       t_0 <- t_1

     }
   })
})

shinyUI(

  fluidPage(title="grm",

  titlePanel("Graded Response Model (Samejima, 1969)"),

    sidebarPanel(width=3,
                 selectInput("D", label = "Item Response Function",
                             list("Normal Ogive" = 1, "Logistic"=2), selected = 2),
        sliderInput("alpha", label = "Discrimination",
                  min = -3, max = 3, value = 1.5, step = .5),
        sliderInput("delta1", label = "Location 1",
                  min = -2.5, max = -1.5, value = -2, step = .1),
        sliderInput("delta2", label = "Location 2",
                    min = -1.25, max = -0.25, value = -0.75, step = .1),
        sliderInput("delta3", label = "Location 3",
                    min = 0, max = 1.25, value = 0.75, step = .1),
        sliderInput("delta4", label = "Location 4",
                    min = 1.5, max = 2.5, value = 2, step = .1)
      ),

    mainPanel(
      plotOutput(outputId="grm_plot",height="600px")
    )
  )
)

thetas <- seq(from=-6, to=6, by=0.1)
deltas <- seq(from=-6, to=6, by=0.1)
alphas <- seq(from=-6, to=6, by=0.1)
N = length(thetas)

# define probability function 
p1num <- matrix(NA,nrow=N,ncol=1)
p2num <- matrix(NA,nrow=N,ncol=1)
p3num <- matrix(NA,nrow=N,ncol=1)
p4num <- matrix(NA,nrow=N,ncol=1)
p5num <- matrix(NA,nrow=N,ncol=1)

p2fun <- function(alpha, theta, delta1, D){
  z1 <- D*alpha*(theta-delta1)
  p2num <- exp(0+z1)
  return(p2num)
}

p3fun <- function(alpha, theta, delta1, delta2, D){
  z1 <- D*alpha*(theta-delta1)
  z2 <- D*alpha*(theta-delta2)
  p3num <- exp(0+z1+z2)
  return(p3num)
}

p4fun <- function(alpha, theta, delta1, delta2, delta3, D){
  z1 <- D*alpha*(theta-delta1)
  z2 <- D*alpha*(theta-delta2)
  z3 <- D*alpha*(theta-delta3)
  p4num <- exp(0+z1+z2+z3)
  return(p4num)
}

p5fun <- function(alpha, theta, delta1, delta2, delta3, delta4, D){
  z1 <- D*alpha*(theta-delta1)
  z2 <- D*alpha*(theta-delta2)
  z3 <- D*alpha*(theta-delta3)
  z4 <- D*alpha*(theta-delta4)
  p5num <- exp(0+z1+z2+z3+z4)
  return(p5num)
}

thetas <- seq(from=-6, to=6, by=0.1)
N = length(thetas)

# define a generic probability function 
Pfun <- function(alpha=1, theta, delta, D=1){
  z = D*alpha*(theta-delta)
  P = 1/(1 + exp(-z))
  return(P)
}

N <- 50
guesses <- seq(from=0.05, to=0.6, by=0.05)
thetas <- seq(from=-3, to=3, length.out = N)
deltas <- seq(from=-3, to=3, by=0.15)
alphas <- seq(from=-3, to=3, by=0.15)
k <- length(deltas)
# define probability function for 3PL model
Pfun <- function(guess, theta, alpha, delta, D=1, u=1){
  z = D*alpha*(theta-delta)
  P = guess + ((1-guess)* exp(z)/(1 + exp(z)))
  if(u==1){return(P)}
  if(u==0){return(1-P)}
}
# assing space for array and matrix
pik <- array(NA,dim=c(k,k,N))
logLike <- matrix(NA,k,k)

shinyServer(function(input, output){
  
  
  output$grm_plot <- renderPlot({
    
    D <- switch(input$D, "1" = 1, "2" = 1.702)
    
    p <- matrix(NA,nrow=N,4)
    for(j in 1:N){
      #p[j,0] <- 0
      p[j,1] <- Pfun(D=D, theta=thetas[j], delta=input$delta1, alpha=input$alpha)
      p[j,2] <- Pfun(D=D, theta=thetas[j], delta=input$delta2, alpha=input$alpha)
      p[j,3] <- Pfun(D=D, theta=thetas[j], delta=input$delta3, alpha=input$alpha)
      p[j,4] <- Pfun(D=D, theta=thetas[j], delta=input$delta4, alpha=input$alpha)
      #p[j,5] <- 1
    }

     graphics::plot(NULL, ylab="P(X=m|theta)", xlab=expression(theta), main="Graded Response Model", xlim=c(-6,6), ylim=c(0,1))
    
    lines(thetas, 1-p[,1], type="l",  xlim=c(-6,6), col=2)
    lines(thetas, p[,1]-p[,2], type="l",  xlim=c(-6,6), col=3)
    lines(thetas, p[,2]-p[,3], type="l",  xlim=c(-6,6), col=4)
    lines(thetas, p[,3]-p[,4], type="l",  xlim=c(-6,6), col=5)
    lines(thetas, p[,4]-0, type="l",  xlim=c(-6,6), col=6)
    legend(legend=c("P(X=1|theta)", "P(X=2|theta)","P(X=3|theta)","P(X=4|theta)","P(X=5|theta)"), col=2:6, lty=1, "right")

  })
})
  

# define prob function
Pfun <- function(theta, delta, D=1, u=1){
  z = D*(theta-delta)
  P = exp(u*z) / (1 + exp(z))
  return(P)
}

deltas <- c(-1.90, -0.60, -0.25, 0.30, 0.45)
thetas <- seq(from=-6, to=6, by=0.001)
N <- length(thetas)
n <- length(deltas)
pji <- matrix(NA,N,n)
logLike <- matrix(NA,N,3)
colnames(logLike) <- c("thetas", "LogLike", "Like")
